//BATMAN! - Yeah - well not all of his powers or it'd be unfair...

/* CVARS - copy and paste to shconfig.cfg

//Batman
batman_level 0
batman_health 125		//default 125
batman_armor 125		//defualt 125

*/

/*
* v1.17 - JTP10181 - 07/23/04
*       - Fixed issue where you could get zoomed in on other primaries if combined with punisher
*
* 5/17 - Took out ammo give to test for a bug
*        + Punisher gets unlimited ammo - so this is desired not to make
*        batman so powerful.  Batman is split between Batman and Punisher
*/

#include <amxmodx>
#include <engine>
#include <cstrike>
#include <shero>

// GLOBAL VARIABLES
new g_heroName[]="Batman"
new g_heroID
new bool:g_hasBatman[SH_MAXSLOTS+1]
new g_currentWeapon[SH_MAXSLOTS+1]
new g_msgSetFOV

#define g_giveTotal 8
new g_weapArray[g_giveTotal][24] = {
	"weapon_flashbang",
	"weapon_smokegrenade",
	"weapon_deagle",
	"weapon_mp5navy",
	"weapon_xm1014",
	"weapon_sg552",
	"weapon_awp",
	"weapon_m4a1"
}
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Batman", "1.18", "{HOJ} Batman/JTP10181")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("batman_level", "0")
	register_cvar("batman_health", "125")
	register_cvar("batman_armor", "125")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	g_heroID = sh_create_hero(g_heroName)
	sh_hero_info(g_heroID, "Utility Belt", "Extra Weapons and HP/AP - Buy the Ammo or Use with Punisher")
	sh_hero_bind(g_heroID, false)
	sh_hero_level(g_heroID, get_cvar_num("batman_level"))

	// REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
	// CURRENT WEAPON
	register_event("CurWeapon", "changeWeapon", "be", "1=1")

	// Let Server know about the heroes variables
	sh_set_hero_vars(g_heroID, get_cvar_num("batman_health"), get_cvar_num("batman_armor"))
	//shSetShieldRestrict(g_heroName)

	g_msgSetFOV = get_user_msgid("SetFOV")
}
//----------------------------------------------------------------------------------------------
public sh_hero_init(id, heroID, mode)
{
	if ( g_heroID == heroID )
	{
		//Reset thier shield restrict status
		//Shield restrict MUST be before weapons are given out
		//shResetShield(id)

		if ( mode == 1 )
		{
			batman_giveweapons(id)
		}
		//This gets run if they had the power but don't anymore
		else if ( g_hasBatman[id] )
		{
			batman_dropweapons(id)
		}

		g_hasBatman[id] = (mode != 0)
	}
}
//----------------------------------------------------------------------------------------------
public sh_new_spawn(id)
{
	if ( sh_server_info(SH_MODACTIVE) && g_hasBatman[id] && is_user_alive(id) )
	{
		set_task(0.1, "batman_giveweapons", id)
	}
}
//----------------------------------------------------------------------------------------------
public batman_giveweapons(id)
{
	if ( !is_user_alive(id) ) return

	for ( new x = 0; x < g_giveTotal; x++ )
	{
		sh_GiveWeapon(id, g_weapArray[x])
	}

	// Give CTs a Defuse Kit
	if ( cs_get_user_team(id) == CS_TEAM_CT ) sh_GiveWeapon(id, "item_thighpack")
}
//----------------------------------------------------------------------------------------------
public batman_dropweapons(id)
{
	if ( !is_user_alive(id) ) return

	for ( new x = 0; x < g_giveTotal; x++ )
	{
		engclient_cmd(id, "drop", g_weapArray[x])
	}

	new iCurrent = -1
	new Float:weapvel[3]

	while ( (iCurrent = find_ent_by_class(iCurrent, "weaponbox")) > 0 )
	{
		//Skip anything not owned by this client
		if ( entity_get_edict(iCurrent, EV_ENT_owner) != id) continue

		//Get Weapon velocites
		entity_get_vector(iCurrent, EV_VEC_velocity, weapvel)

		//If Velocities are all Zero its on the ground already and should stay there
		if ( weapvel[0] == 0.0 && weapvel[1] == 0.0 && weapvel[2] == 0.0 ) continue

		remove_entity(iCurrent)
	}
}
//----------------------------------------------------------------------------------------------
public changeWeapon(id)
{
	if ( !sh_server_info(SH_MODACTIVE) || !g_hasBatman[id] ) return

	new weaponid = read_data(2)

	if ( g_currentWeapon[id] != weaponid )
	{
		g_currentWeapon[id] = weaponid
		batman_zoomout(id)
	}
}
//----------------------------------------------------------------------------------------------
public batman_zoomout(id)
{
	if ( !is_user_alive(id) ) return
	message_begin(MSG_ONE, g_msgSetFOV, {0,0,0}, id)
	write_byte(90) 	//not Zooming
	message_end()
}
//----------------------------------------------------------------------------------------------
public client_connect(id)
{
	g_hasBatman[id] = false
}
//----------------------------------------------------------------------------------------------