// Cyclops! - Cool Laser Guy From Xmen (Yeah - Luds Laser Ripoff :D)

/* CVARS - copy and paste to shconfig.cfg

//Cyclops
cyclops_level 5
cyclops_laser_ammo 20			//total # of shots given each round
cyclops_laser_burndecals 1		//Show the burn decals on the walls
cyclops_cooldown 0.20			//Cooldown timer between shots
cyclops_multishot 0.20			//Delay for multishots on holding key down

*/

#include <amxmodx>
#include <cstrike>
#include <shero>

// Damage Variables
#define h1_dam 100 //head
#define h2_dam 56  //body
#define h3_dam 56  //stomach
#define h4_dam 36  //arm
#define h6_dam 36  //leg

// GLOBAL VARIABLES
new g_heroName[]="Cyclops"
new g_heroID
new bool:g_hasCyclops[SH_MAXSLOTS+1]
new bool:g_usingLaser[SH_MAXSLOTS+1]
new g_lastWeapon[SH_MAXSLOTS+1]
new g_laserShots[SH_MAXSLOTS+1]
new g_spriteSmoke, g_spriteLaser
static const g_burnDecal[5] = {199,200,201,202,203}
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Cyclops", "1.18", "AssKicR/Batman/JTP10181")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("cyclops_level", "5")
	register_cvar("cyclops_laser_ammo", "20")  // total # of shots...
	register_cvar("cyclops_laser_burndecals", "1")
	register_cvar("cyclops_cooldown", "0.20")
	register_cvar("cyclops_multishot", "0.20") //Delay for multishots on holding key down

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	g_heroID = sh_create_hero(g_heroName)
	sh_hero_info(g_heroID, "Optic Blast", "Press the +power key to fire your optic laser beam")
	sh_hero_bind(g_heroID, true)
	sh_hero_level(g_heroID, get_cvar_num("cyclops_level"))

	// REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
	// DEATH
	register_event("DeathMsg", "cyclops_death", "a")
}
//----------------------------------------------------------------------------------------------
public plugin_precache()
{
	g_spriteSmoke = precache_model("sprites/steam1.spr")
	g_spriteLaser = precache_model("sprites/laserbeam.spr")
	precache_sound("weapons/electro5.wav")
	precache_sound("weapons/xbow_hitbod2.wav")
}
//----------------------------------------------------------------------------------------------
public sh_hero_init(id, heroID, mode)
{
	if ( g_heroID == heroID )
	{
		if ( mode == 1 )
		{
			sh_uset(id, g_heroID, 0)
			g_laserShots[id] = get_cvar_num("cyclops_laser_ammo")
		}
		g_hasCyclops[id] = (mode != 0)
	}
}
//----------------------------------------------------------------------------------------------
public sh_new_spawn(id)
{
	remove_task(id)
	g_laserShots[id] = get_cvar_num("cyclops_laser_ammo")
	sh_uset(id, g_heroID, 0)
}
//----------------------------------------------------------------------------------------------
// RESPOND TO KEYDOWN
public sh_hero_key(id, heroID, key)
{
	if ( g_heroID != heroID ) return

	if ( key == 1 )
	{
		if ( !sh_server_info(SH_INROUND) ) return
		if ( !is_user_alive(id) ) return

		if ( g_laserShots[id] <= 0 )
		{
			client_print(id, print_center, "No Cyclops Optic Blasts Left")
			playSoundDenySelect(id)
			return
		}

		if ( sh_ustatus(id, g_heroID) )
		{
			playSoundDenySelect(id)
			return
		}

		// Remember this weapon...
		new clip, ammo, weaponID = get_user_weapon(id, clip, ammo)
		g_lastWeapon[id] = weaponID

		// switch to knife
		engclient_cmd(id,"weapon_knife")

		g_usingLaser[id] = true
		fire_laser(id)  // 1 immediate shot
		if ( get_cvar_float("cyclops_multishot") > 0.0 )
		{
			set_task( get_cvar_float("cyclops_multishot"), "fire_laser", id, "", 0, "b")  //delayed shots
		}
	}
	else
	{
		remove_task(id)

		if ( !sh_server_info(SH_INROUND) ) return

		if ( !g_usingLaser[id] ) return

		// Use the ultimate
		sh_utimer(id, g_heroID, get_cvar_float("cyclops_cooldown"))

		//Reset check var
		g_usingLaser[id] = false

		// Switch back to previous weapon...
		if ( g_lastWeapon[id] != CSW_KNIFE ) sh_SwitchWeaponID(id, g_lastWeapon[id])
	}
}
//----------------------------------------------------------------------------------------------
public laserEffects(id, aimvec[3])
{
	new origin[3]
	new decal_id = g_burnDecal[random_num(0,4)]
	emit_sound(id, CHAN_ITEM, "weapons/electro5.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
	get_user_origin(id, origin, 1)

	// DELIGHT
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(27)
	write_coord(origin[0])	//pos
	write_coord(origin[1])
	write_coord(origin[2])
	write_byte(10)
	write_byte(250)	// r, g, b
	write_byte(0)		// r, g, b
	write_byte(0)		// r, g, b
	write_byte(2)		// life
	write_byte(1)		// decay
	message_end()

	//BEAMENTPOINTS
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte (0)			//TE_BEAMENTPOINTS
	write_coord(origin[0])
	write_coord(origin[1])
	write_coord(origin[2])
	write_coord(aimvec[0])
	write_coord(aimvec[1])
	write_coord(aimvec[2])
	write_short(g_spriteLaser)
	write_byte(1)		// framestart
	write_byte(5)		// framerate
	write_byte(2)		// life
	write_byte(40)		// width
	write_byte(0)		// noise
	write_byte(250)	// r, g, b
	write_byte(0)		// r, g, b
	write_byte(0)		// r, g, b
	write_byte(200)	// brightness
	write_byte(200)	// speed
	message_end()

	//Sparks
	message_begin(MSG_PVS, SVC_TEMPENTITY)
	write_byte(9)
	write_coord(aimvec[0])
	write_coord(aimvec[1])
	write_coord(aimvec[2])
	message_end()

	//Smoke
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(5)		//
	write_coord(aimvec[0])
	write_coord(aimvec[1])
	write_coord(aimvec[2])
	write_short(g_spriteSmoke)
	write_byte(22)		// 10
	write_byte(10)		// 10
	message_end()

	if ( get_cvar_num("cyclops_laser_burndecals") == 1 )
	{
		//TE_GUNSHOTDECAL
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(109)		// decal and ricochet sound
		write_coord(aimvec[0])	//pos
		write_coord(aimvec[1])
		write_coord(aimvec[2])
		write_short(0)			// I have no idea what thats supposed to be
		write_byte(decal_id)	//decal
		message_end()
	}
}
//----------------------------------------------------------------------------------------------
public fire_laser(id)
{
	new aimvec[3]
	new tid, tbody
	new FFOn = get_cvar_num("mp_friendlyfire")

	if( !is_user_alive(id) ) return

	if ( g_laserShots[id] <= 0 )
	{
		client_print(id, print_center, "No Cyclops Optic Blasts Left")
		playSoundDenySelect(id)
		return
	}

	// Make sure still on knife
	new clip, ammo, weaponID = get_user_weapon(id, clip, ammo)
	if ( weaponID != CSW_KNIFE ) engclient_cmd(id, "weapon_knife")

	// Warn How many Blasts Left...
	g_laserShots[id]--
	if ( g_laserShots[id] < 6 ) client_print(id, print_center, "Warning: %d Cyclops Optic Blasts Left", g_laserShots[id])

	get_user_origin(id, aimvec, 3)
	laserEffects(id, aimvec)

	get_user_aiming(id, tid, tbody)

	if ( is_user_alive(tid) && (FFOn || cs_get_user_team(id) != cs_get_user_team(tid)) )
	{
		emit_sound(tid, CHAN_BODY, "weapons/xbow_hitbod2.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

		// Determine the damage
		new damage
		switch(tbody)
		{
			case 1: damage = h1_dam
			case 2: damage = h2_dam
			case 3: damage = h3_dam
			case 4: damage = h4_dam
			case 5: damage = h4_dam
			case 6: damage = h6_dam
			case 7: damage = h6_dam
		}

		// Deal the damage...
		sh_extradamage(tid, id, damage, "Optic Blast")
	}
}
//----------------------------------------------------------------------------------------------
public cyclops_death()
{
	new id = read_data(2)

	if ( id <= 0 || id > SH_MAXSLOTS ) return

	remove_task(id)
}
//----------------------------------------------------------------------------------------------
public client_disconnect(id)
{
	// stupid check but lets see
	if ( id <= 0 || id > SH_MAXSLOTS ) return

	// Yeah don't want any left over residuals
	remove_task(id)
	g_hasCyclops[id] = false
}
//----------------------------------------------------------------------------------------------