// WOLVERINE!

/* CVARS - copy and paste to shconfig.cfg

//Wolverine
wolv_level 0
wolv_healpoints 3			//The # of HP healed per second
wolv_knifespeed 290			//Speed of wolveine in knife mode
wolv_knifemult 1.35			//Multiplier for knife damage

*/

// v1.17 - JTP - fixed runtime error on damage event if user is already dead
// v1.17.5 - JTP - Added code to allow you to regen to your max heatlh

#include <amxmodx>
#include <shero>

// GLOBAL VARIABLES
new g_heroName[]="Wolverine"
new g_heroID
new bool:g_hasWolverine[SH_MAXSLOTS+1]
new g_playerMaxHealth[SH_MAXSLOTS+1]
new g_healPoints
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Wolverine", "1.18", "{HOJ} Batman/JTP10181")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("wolv_level", "0")
	register_cvar("wolv_healpoints", "3")
	register_cvar("wolv_knifespeed", "290")
	register_cvar("wolv_knifemult", "1.35")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	g_heroID = sh_create_hero(g_heroName)
	sh_hero_info(g_heroID, "Auto-Heal & Claws", "Auto-Heal, Extra Knife Damage and Speed")
	sh_hero_bind(g_heroID, false)
	sh_hero_level(g_heroID, get_cvar_num("wolv_level"))

	// REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
	// DAMAGE EVENT
	register_event("Damage", "wolv_damage", "b", "2!0")

	// HEAL LOOP
	set_task(1.0, "wolv_loop", 0, "", 0, "b")

	// Let Server know about the heroes variables
	sh_set_hero_speed(g_heroID, get_cvar_float("wolv_knifespeed"), 1, {29})

	g_healPoints = get_cvar_num("wolv_healpoints")
}
//----------------------------------------------------------------------------------------------
public sh_hero_init(id, heroID, mode)
{
	if ( g_heroID == heroID )
	{
		g_hasWolverine[id] = (mode != 0)
	}

	if ( g_hasWolverine[id] )
	{
		if ( sh_max_hp(id) < 100 ) g_playerMaxHealth[id] = 100
		else g_playerMaxHealth[id] = sh_max_hp(id)
	}
}
//----------------------------------------------------------------------------------------------
public wolv_loop()
{
	if ( !sh_server_info(SH_MODACTIVE) ) return
	for ( new id = 1; id <= SH_MAXSLOTS; id++ )
	{
		if ( g_hasWolverine[id] && is_user_alive(id) )
		{
			// Let the server add the hps back since the # of max hps is controlled by it
			// I.E. Superman has more than 100 hps etc.
			sh_addhp(id, g_healPoints, g_playerMaxHealth[id])
		}
	}
}
//----------------------------------------------------------------------------------------------
public wolv_damage(id)
{
	if ( !sh_server_info(SH_MODACTIVE) || !is_user_alive(id) ) return

	new damage = read_data(2)
	new weapon, bodypart, attacker = get_user_attacker(id, weapon, bodypart)
	new headshot = bodypart == 1 ? 1 : 0

	if ( attacker <= 0 || attacker > SH_MAXSLOTS ) return

	if ( g_hasWolverine[attacker] && weapon == CSW_KNIFE && is_user_alive(id) )
	{
		// do extra damage
		new extraDamage = floatround(damage * get_cvar_float("wolv_knifemult") - damage)
		if (extraDamage > 0) sh_extradamage(id, attacker, extraDamage, "knife", headshot)
	}
}
//----------------------------------------------------------------------------------------------